using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using FiltronASP.Logger;

namespace FiltronASP.Models.DAO
{
    public class MenuDAO : Abstracts.AbstractGenericDAO<Menu, System.Nullable<int>>,
        Interfaces.IMenuDAO
    {
        /// <summary>
        /// Metoda zwracajaca nazwe parametru bedacego kluczem glownym tabeli.
        /// </summary>
        /// <returns>nazwa klucza glownego</returns>
        protected override string GetKeyProperty()
        {
            return "menu_id";
        }

        /// <summary>
        /// Pobieranie listy obiektow na podstawie ich języka.
        /// </summary>
        /// <param name="languageId">język</param>
        /// <returns>lista rekordow o zadanym języku</returns>
        public IQueryable<Menu> FindByLanguageId(int languageId)
        {
            if (languageId.Equals(0))
            {
                return null;
            }   //if
            try
            {
                IQueryable<Menu> menus = this._cmsEntitiesDataContext.Menus.Where(
                    lang => lang.language_id.Equals(languageId)
                        );
                if (!(menus.Any()))
                {
                    return null;
                }   //if
                return menus;
            }   //try
            catch (Exception ex)
            {
                MyLogger.Log(ex);
            }   //catch
            return null;
        }

        /// <summary>
        /// Pobieranie obiektu na podstawie ich języka.
        /// </summary>
        /// <param name="languageId">jezyk</param>
        /// <param name="name">nazwa</param>
        /// <returns>Rekord o zadanym jezyku i nazwie</returns>
        public Menu FindByLanguageIdAndName(int languageId, string name)
        {
            if (languageId.Equals(0) || String.IsNullOrEmpty(name))
            {
                return null;
            }   //if
            try
            {
                Menu menu = this._cmsEntitiesDataContext.Menus.SingleOrDefault(
                    men => men.language_id.Equals(languageId) && men.menu_name.Equals(name)
                        );

                return menu;
            }   //try
            catch (Exception ex)
            {
                MyLogger.Log(ex);
            }   //catch
            return null;
        }

        /// <summary>
        /// Wstawianie listy obiektów na podstawie jezyka.
        /// </summary>
        /// <param name="defaultLanguageId">domyslny jezyk</param>
        /// <param name="newLanguageId">nowy jezyk</param>
        /// <returns>true jesli sie udalo, false wpp</returns>
        public bool InsertForNewLanguage(int defaultLanguageId, int newLanguageId)
        {
            if (defaultLanguageId.Equals(0) || newLanguageId.Equals(0))
            {
                return false;
            }   //if
            try
            {
                IQueryable<Menu> menus = this.FindByLanguageId(defaultLanguageId);
                ModuleDAO _moduleDAO = new ModuleDAO();
                if (menus == null)
                {
                    return true;
                }   //if
                if (!(menus.Any()))
                {
                    return true;
                }   //if
                foreach (Menu menu in menus)
                {
                    Module oldModule = _moduleDAO.FindByPK(menu.module_id);
                    if (oldModule == null)
                    {
                        return false;
                    }
                    Module newModule = _moduleDAO.FindByLanguageIdAndModuleName(newLanguageId, oldModule.module_name);
                    if (newModule == null)
                    {
                        return false;
                    }
                    Menu menuToInsert = new Menu();
                    menuToInsert.language_id = newLanguageId;
                    menuToInsert.menu_created = DateTime.Now;
                    menuToInsert.menu_description = menu.menu_description;
                    menuToInsert.menu_hidden = menu.menu_hidden;
                    menuToInsert.menu_modified = DateTime.Now;
                    menuToInsert.menu_name = menu.menu_name;
                    menuToInsert.module_id = newModule.module_id;
                    this.Add(menuToInsert);
                }

            }   //try
            catch (Exception ex)
            {
                MyLogger.Log(ex);
            }   //catch
            return true;
        }

        /// <summary>
        /// Usuwanie obiektow po jezyku.
        /// </summary>
        /// <param name="languageId">jezyk</param>
        /// <returns>true dla sukcesu, false w przeciwnym razie</returns>
        public bool DeleteByLanguage(int languageId)
        {
            if (languageId.Equals(0))
            {
                return false;
            }   //if
            try
            {
                IQueryable<Menu> menus = this.FindByLanguageId(languageId);
                if (menus == null)
                {
                    return true;
                }   //if
                if (!(menus.Any()))
                {
                    return true;
                }   //if
                foreach (Menu menu in menus)
                {
                    this._cmsEntitiesDataContext.Menus.DeleteOnSubmit(menu);
                }
                try
                {
                    _cmsEntitiesDataContext.SubmitChanges();

                }
                catch (Exception ex)
                {
                    MyLogger.Log(ex);
                }   //catch
                return true;
            }   //try
            catch (Exception ex)
            {
                MyLogger.Log(ex);
            }   //catch
            return false;
        }
    }
}
